package mp

import "encoding/xml"

// Event 公众号事件
type Event struct {
	XMLName      xml.Name `xml:"xml"`
	ToUserName   CDATA    `xml:"ToUserName"`
	FromUserName CDATA    `xml:"FromUserName"`
	CreateTime   int64    `xml:"CreateTime"`
	MsgType      CDATA    `xml:"MsgType"`
	Event        CDATA    `xml:"Event"`
}

// SubscribeEvent 关注/取消关注事件
// event subscribe(订阅)、unsubscribe(取消订阅)
type SubscribeEvent struct {
	Event
}

// QRSceneEvent 扫描带参数二维码事件
type QRSceneEvent struct {
	Event
	EventKey CDATA `xml:"EventKey"`
	Ticket   CDATA `xml:"Ticket"`
}

// LocationEvent 上报地理位置事件
type LocationEvent struct {
	Event
	Latitude  float64 `xml:"Latitude"`
	Longitude float64 `xml:"Longitude"`
	Precision float64 `xml:"Precision"`
}

// MenuEvent 自定义菜单事件
// event 值为 CLICK
type MenuEvent struct {
	Event
	EventKey CDATA `xml:"EventKey"`
}
